VERSION 5.00
Begin VB.UserControl ControlVScrollBarDR 
   Alignable       =   -1  'True
   BackColor       =   &H8000000D&
   ClientHeight    =   3210
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   690
   ControlContainer=   -1  'True
   ScaleHeight     =   3210
   ScaleWidth      =   690
   Begin VB.PictureBox PictImg 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFC0C0&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   1905
      Left            =   15
      ScaleHeight     =   1905
      ScaleWidth      =   495
      TabIndex        =   2
      Top             =   570
      Width           =   495
      Begin VB.Label LblSlider 
         BackColor       =   &H8000000D&
         BackStyle       =   0  'Transparent
         ForeColor       =   &H8000000E&
         Height          =   1455
         Left            =   0
         TabIndex        =   3
         Top             =   435
         Width           =   495
      End
      Begin VB.Image ImgCurseur 
         Height          =   480
         Left            =   -30
         Picture         =   "ControlVScrollBarDR .ctx":0000
         Top             =   15
         Width           =   480
      End
   End
   Begin VB.PictureBox PictHaut 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   495
      Left            =   45
      ScaleHeight     =   495
      ScaleWidth      =   435
      TabIndex        =   1
      Top             =   45
      Width           =   435
   End
   Begin VB.PictureBox PictBas 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   480
      Left            =   30
      ScaleHeight     =   480
      ScaleWidth      =   435
      TabIndex        =   0
      Top             =   2490
      Width           =   435
   End
   Begin VB.Timer Timer1 
      Left            =   225
      Top             =   90
   End
End
Attribute VB_Name = "ControlVScrollBarDR"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'//////////////////////////////////////
'/
'/  scrollbarVertical de VA 2.0
'/
'/
'/  Control ralis par : Didier ROBIN
'/
'/  Le 11.07.2000
'/
'//////////////////////////////////////


Option Explicit

'Dclaration des fonction API
Private Type POINTAPI
        X As Long
        Y As Long
End Type
Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type


Private Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function GetClipCursor Lib "user32" (lprc As RECT) As Long
Private Declare Function ClipCursor Lib "user32" (lpRect As RECT) As Long

'Classe DrawingTool
Private MyDrawingTool As New DrawingTool

'Dclaration des variables
Private ClipRect As RECT
Private Rectimg As RECT
Private m_Pas As Single
Private m_Height As Single
Private m_ZHeight As Single
Private m_st As Boolean
Private Result As Single
Private m_PosCurY As Single
Private m_Max As Long
Private m_Min As Integer
Private m_BoutonHaut As Boolean
Private m_BoutonBas As Boolean
Private m_Large As Single
Private newvalue As Long
Private m_DelayRep As Integer
Private m_ClickBouton As Boolean
 
'Evenement ScrollBar
Public Event Change(m_value As Long)
 
'Fonction calcul la position de la souris en Vertical (Y)
Private Function CalSizeY(ObjPic As Object, MyTop As Single, Y As Single) As Single
'                ++++++++
Dim a As Single, b As Single, c As Single

a = (ObjPic.Height - MyTop)
b = (ObjPic.Height - Y)
c = (a - b)

CalSizeY = c

End Function

 
'Positionne le curseur de la barre de dfilement
Private Sub LblSlider_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
'           +++++++++++++++++++
Dim Tmp As Long
   
    If Y > ImgCurseur.Height / 2 And Y < PictImg.Height - (ImgCurseur.Height / 2) Then
        
        If Y > ImgCurseur.Top And Y < (ImgCurseur.Top + ImgCurseur.Height) And Button <> 255 Then
            Result = CalSizeY(PictImg, ImgCurseur.Top, Y)
            ImgCurseur.Top = Y - Result
        Else
            
            ImgCurseur.Top = Y - (ImgCurseur.Height / 2)
            Result = CalSizeY(PictImg, ImgCurseur.Top, Y)
            Tmp = ((Y - Result) * (m_Max - m_Min) / (PictImg.Height - ImgCurseur.Height)) + m_Min
            
            If Tmp <= m_Min Then
               Tmp = m_Min
            ElseIf Tmp >= m_Max Then
                 Tmp = m_Max
            End If
            
        End If
       
    ElseIf Y <= ImgCurseur.Height / 2 Then
        ImgCurseur.Top = 0
        Tmp = m_Min
    Else
        ImgCurseur.Top = PictImg.Height - ImgCurseur.Height
        Tmp = m_Max
    End If
    
    'si la valeur a chang
    If newvalue <> Tmp Then
        
        newvalue = Tmp
    
        ImgCurseur.Refresh
    
        RaiseEvent Change(newvalue)
    
    End If
    
End Sub


 
'Dplacement du curseur de la barre dfilement
Private Sub LblSlider_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'           +++++++++++++++++

Dim m_Point As POINTAPI
Dim Tmp As Long

Select Case Button
    Case 0
        If m_st = True Then
            Call ClipCursor(ClipRect)
            m_st = False
        End If
    Case 1
        
   
        If m_st = False Then
            Result = CalSizeY(PictImg, ImgCurseur.Top, Y)
            m_st = True
            Call ClientToScreen(PictImg.hwnd, m_Point)
            Rectimg.Left = m_Point.X
            Rectimg.Top = m_Point.Y + Result / 15
            Rectimg.Right = m_Point.X + PictImg.Width / 15
            Rectimg.Bottom = m_Point.Y + ((PictImg.Height - (-Result + ImgCurseur.Height)) / 15) + 1
            Call ClipCursor(Rectimg)
        End If
 

        m_ClickBouton = True
         
        If Y >= ImgCurseur.Top - 100 And Y <= ImgCurseur.Top + ImgCurseur.Height + 100 Then
        
            ImgCurseur.Top = Y - Result
            Tmp = ((Y - Result) * (m_Max - m_Min) / (PictImg.Height - ImgCurseur.Height)) + m_Min
            
            If Tmp <= m_Min Then
                Tmp = m_Min
            ElseIf Tmp >= m_Max Then
                 Tmp = m_Max
            End If
            
            'si la valeur a chang
            If newvalue <> Tmp Then
                
                newvalue = Tmp
            
                ImgCurseur.Refresh
            
                RaiseEvent Change(newvalue)
            
            End If
            
        End If

End Select

End Sub

'Bouton haut enfonc de la barre de dfilement
Private Sub PictHaut_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
'           ++++++++++++++++++
m_BoutonHaut = True
Timer1.Interval = m_DelayRep
Timer1.Enabled = True
Call Triangle(PictHaut, 15 * 10, 15 * 10, "<", 10)
Call BoutonHautBas
End Sub

'Bouton haut relach de la barre de dfilement
Private Sub PictHaut_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
'           ++++++++++++++++
m_BoutonHaut = False
Timer1.Enabled = False
Call Triangle(PictHaut, 15 * 10, 15 * 10, "<", 0)
End Sub

'Bouton Bas enfonc de la barre de dfilement
Private Sub PictBas_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
'           +++++++++++++++++
m_BoutonBas = True
Timer1.Interval = m_DelayRep
Timer1.Enabled = True
Call Triangle(PictBas, 15 * 10, 15 * 10, ">", 10)
Call BoutonHautBas
End Sub

'Bouton Bas relach de la barre de dfilement
Private Sub PictBas_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
'           +++++++++++++++
m_BoutonBas = False
Timer1.Enabled = False
Call Triangle(PictBas, 15 * 10, 15 * 10, ">", 0)
End Sub



'Dplacement du curseur par le biais des boutons haut et bas
Private Sub BoutonHautBas()
'           +++++++++++++

If m_ClickBouton = True Then
    m_PosCurY = ImgCurseur.Top + ImgCurseur.Height / 2
    m_ClickBouton = False
End If
    
If m_BoutonHaut = True Then
    
    If m_PosCurY >= ImgCurseur.Height / 2 Then m_PosCurY = m_PosCurY - m_Large
    Call LblSlider_MouseDown(255, 0, 0, m_PosCurY)
    If m_PosCurY >= PictImg.Height - ImgCurseur.Height / 2 Then m_PosCurY = PictImg.Height - ImgCurseur.Height / 2
    
ElseIf m_BoutonBas = True Then
    
    If m_PosCurY <= PictImg.Height - ImgCurseur.Height / 2 Then m_PosCurY = m_PosCurY + m_Large
    Call LblSlider_MouseDown(255, 0, 0, m_PosCurY)
    If m_PosCurY <= ImgCurseur.Height / 2 Then m_PosCurY = ImgCurseur.Height / 2
    

End If

End Sub


'Timer de rptition des boutons enfoncs haut et bas
Private Sub Timer1_Timer()
'           ++++++++++++

Timer1.Interval = 1
Call BoutonHautBas

End Sub

'Initialisation du clipping souris
Private Sub UserControl_Initialize()
'           ++++++++++++++++++++++
Dim m_Point As POINTAPI

Call GetClipCursor(ClipRect)

Call ClientToScreen(PictImg.hwnd, m_Point)
Rectimg.Left = m_Point.X
Rectimg.Top = m_Point.Y
Rectimg.Right = m_Point.X + PictImg.Width / 15
Rectimg.Bottom = m_Point.Y + PictImg.Height / 15


End Sub

'Redimensionnement de la barre de dfilement
Private Sub UserControl_Resize()
'           +++++++++++++++++

Dim i As Integer
Dim MyControl As Control

For Each MyControl In ContainedControls
    If Left(MyControl.Name, 5) = "Image" Then
        ImgCurseur.Picture = MyControl.Picture
    End If
Next


With PictHaut
    .Top = 0
    .Left = 0
    .Width = Width
    .Height = 435
End With

With PictBas
    
    .Width = Width
    .Left = 0
    .Height = 435
    .Top = Height - .Height
End With

With PictImg
    .Top = PictHaut.Height + 15
    .Left = 0
    .Width = Width
    If (Height - PictBas.Height - PictHaut.Height - 30) > 0 Then
        .Height = Height - PictBas.Height - PictHaut.Height - 30
    Else
         .Height = Height
    End If
    
End With


With LblSlider
    .Top = 0
    .Left = 0
    .Width = PictImg.Width
    .Height = PictImg.Height
End With

m_Height = PictImg.Height
m_ZHeight = ImgCurseur.Height
m_Pas = m_Height / m_ZHeight

With ImgCurseur
    .Top = 0
    .Width = (PictImg.Width / m_Pas) 'Supprime Stretch
    If .Width < Width Then
        .Stretch = False
        .Left = (PictImg.Width / 2 - .Width / 2)
    Else
       .Stretch = True
       .Left = 0
       .Width = Width
    End If
    
End With

MyDrawingTool.Fill_degrade PictImg, LEFT_TO_RIGHT, rgb(253, 253, 254), rgb(23, 3, 134)
MyDrawingTool.Fill_degrade PictBas, LEFT_TO_RIGHT, rgb(253, 253, 254), rgb(23, 3, 134)
MyDrawingTool.Fill_degrade PictHaut, LEFT_TO_RIGHT, rgb(253, 253, 254), rgb(23, 3, 134)

Call Triangle(PictHaut, 15 * 10, 15 * 10, "<", 0)
Call Triangle(PictBas, 15 * 10, 15 * 10, ">", 0)
 
End Sub

'Affichage des triangles haut et bas
Public Sub Triangle(Img As PictureBox, Width As Single, Height As Single, Fleche As String, Couleur As Integer)
'          ++++++++
Dim i As Integer
Dim X As Single
Dim Y As Single

X = Img.Width / 2 - Width / 2
Y = Img.Height / 2 - Height / 2

Img.ForeColor = QBColor(Couleur)

If Fleche = "<" Then
    For i = 0 To Height
        Img.Line (X + Width / 2, Y)-(X + i, Y + Height)
    Next
    
ElseIf Fleche = ">" Then
     For i = 0 To Height
        Img.Line (X + Width / 2, Y + Height)-(X + i, Y)
    Next

End If

End Sub

'Retourne la valeur de la position du curseur
Public Property Get Value() As Integer
'                   +++++
Value = newvalue
End Property

'Positionne le curseur
Public Property Let Value(ByVal vNewValue As Integer)
'                   +++++

Call LblSlider_MouseDown(1, 0, 0, (vNewValue * m_Pas) + ImgCurseur.Width / 2)

End Property

'delay de rptition des boutons haut et bas
Public Property Let DelayRep(ByVal vNewValue As Integer)
'                   +++++++
m_DelayRep = vNewValue
End Property

'Affectation de la Valeur Maximum
Public Property Let Max(ByVal vNewValue As Single)
'                   +++
m_Max = vNewValue
End Property

'Retourne la valeur maximum
Public Property Get Max() As Single
'                   +++
Max = m_Max
End Property

'Affectation de la minimum
Public Property Let Min(ByVal vNewValue As Single)
'                   +++
m_Min = vNewValue
End Property

'Retourne la valeur minimum
Public Property Get Min() As Single
'                   +++
Min = m_Min
End Property

'Affectation de la variable de dplacement du curseur a l'aide des boutons haut et bas
Public Property Let Large(ByVal vNewValue As Single)
'                   +++++
m_Large = vNewValue

End Property




 
