VERSION 5.00
Begin VB.UserControl ControlPoigne 
   BackStyle       =   0  'Transparent
   ClientHeight    =   450
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   480
   MaskColor       =   &H8000000E&
   MaskPicture     =   "ControlPoigne.ctx":0000
   Picture         =   "ControlPoigne.ctx":0292
   ScaleHeight     =   450
   ScaleWidth      =   480
   Begin VB.Timer TimerSouris 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   0
      Top             =   0
   End
End
Attribute VB_Name = "ControlPoigne"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'////////////////////////////////////
'/
'/  Control poigne de VA 2.0
'/
'/
'/  A LEROY le 14.06.2000
'/
'////////////////////////////////////
'API de conversion de position de souris
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long

'Dclaration des types
Private Type POINTAPI
        X As Long
        Y As Long
End Type

'dclaration des variables prives
Private m_enabled As Boolean

'Dclaration des venements
Public Event Click()
Public Event DblClick()
Public Event MouseOver()
Public Event MouseOut()
Public Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

'Traitement du click sur le control utilisateur
Private Sub UserControl_Click()
'           +++++++++++++++++

    RaiseEvent Click

End Sub

'traitement du double click sur le control utilisateur
Private Sub UserControl_DblClick()
'           ++++++++++++++++++++

    RaiseEvent DblClick

End Sub

'traitement du mouseDown sur le control utilisateur
Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
'           +++++++++++++++++++++

    RaiseEvent MouseDown(Button, Shift, X, Y)
    
End Sub

'traitement du mouseMove sur le control utilisateur
Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'           +++++++++++++++++++++

    RaiseEvent MouseMove(Button, Shift, X, Y)
    
End Sub

'traitement du mouseUp sur le control utilisateur
Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
'           +++++++++++++++++++++

    RaiseEvent MouseUp(Button, Shift, X, Y)
    
End Sub

'Timer de traitement du MouseOver et du MouseOut
Private Sub TimerSouris_Timer()
'           +++++++++++++++++

    Dim res As Long
    Dim MousPos As POINTAPI
    Dim CtlPos As POINTAPI
    Dim Myctl As Control
                  
    res = GetCursorPos(MousPos)
                
    'conversion de la position du control en coordonnes cran
    CtlPos.X = 0
    CtlPos.Y = 0

    res = ClientToScreen(UserControl.hwnd, CtlPos)
   
    'le curseur est dans le control
    If MousPos.X > CtlPos.X And MousPos.Y > CtlPos.Y And MousPos.X < CtlPos.X + Myctl.Width And MousPos.Y < CtlPos.Y + Myctl.Height Then
        
        RaiseEvent MouseOver
       
    'le curseur n'est pas dans le control
    Else
        
        RaiseEvent MouseOut
        
    End If
    
       
    DoEvents

End Sub

'Proprit d'activation du control
Public Property Get Enabled() As Boolean
'                   +++++++

    Enabled = m_enabled

End Property

Public Property Let Enabled(ByVal vNewValue As Boolean)
'                   +++++++

    m_enabled = vNewValue
    
    TimerSouris.Enabled = m_enabled

End Property
